package org.jeecg.modules.stm.projectbase.project.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.projectbase.project.entity.StProjectManage;
import org.jeecg.modules.stm.projectbase.project.service.IStProjectManageService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: 项目管理
 * @Author: jeecg-boot
 * @Date: 2023-08-12
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/projectbase.project/stProjectManage")
@Slf4j
public class StProjectManageController extends JeecgController<StProjectManage, IStProjectManageService> {
	@Autowired
	private IStProjectManageService stProjectManageService;

	/**
	 * 分页列表查询
	 *
	 * @param stProjectManage
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	// @AutoLog(value = "项目管理-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StProjectManage>> queryPageList(StProjectManage stProjectManage,
			@RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
			@RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
		QueryWrapper<StProjectManage> queryWrapper = QueryGenerator.initQueryWrapper(stProjectManage,
				req.getParameterMap());
		Page<StProjectManage> page = new Page<StProjectManage>(pageNo, pageSize);
		if (stProjectManage.getProjectName() != null) {
			queryWrapper.like("Project_Name", "%" + stProjectManage.getProjectName() + "%");
		}
		if (stProjectManage.getProjectType() != null) {
			queryWrapper.eq("Project_Type", stProjectManage.getProjectType());
		}
		if (stProjectManage.getStatus() != null) {
			queryWrapper.eq("status", stProjectManage.getStatus());
		}
		queryWrapper.orderByDesc("created_Time");
		IPage<StProjectManage> pageList = stProjectManageService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 * 添加
	 *
	 * @param stProjectManage
	 * @return
	 */
	@AutoLog(value = "项目管理-添加")
	  
	@RequiresPermissions("projectbase.project:st_project_manage:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StProjectManage stProjectManage) {
		stProjectManageService.save(stProjectManage);
		return Result.OK("添加成功！");
	}

	/**
	 * 编辑
	 *
	 * @param stProjectManage
	 * @return
	 */
	@AutoLog(value = "项目管理-编辑")
	  
	@RequiresPermissions("projectbase.project:st_project_manage:edit")
	@RequestMapping(value = "/edit", method = { RequestMethod.PUT, RequestMethod.POST })
	public Result<String> edit(@RequestBody StProjectManage stProjectManage) {
		stProjectManageService.updateById(stProjectManage);
		return Result.OK("编辑成功!");
	}

	/**
	 * 通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "项目管理-通过id删除")
	  
	@RequiresPermissions("projectbase.project:st_project_manage:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
		stProjectManageService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "项目管理-批量删除")
	  
	@RequiresPermissions("projectbase.project:st_project_manage:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
		this.stProjectManageService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	// @AutoLog(value = "项目管理-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StProjectManage> queryById(@RequestParam(name = "id", required = true) String id) {
		StProjectManage stProjectManage = stProjectManageService.getById(id);
		if (stProjectManage == null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stProjectManage);
	}

	/**
	 * 导出excel
	 *
	 * @param request
	 * @param stProjectManage
	 */
	@RequiresPermissions("projectbase.project:st_project_manage:exportXls")
	@RequestMapping(value = "/exportXls")
	public ModelAndView exportXls(HttpServletRequest request, StProjectManage stProjectManage) {
		return super.exportXls(request, stProjectManage, StProjectManage.class, "项目管理");
	}

	/**
	 * 通过excel导入数据
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequiresPermissions("projectbase.project:st_project_manage:importExcel")
	@RequestMapping(value = "/importExcel", method = RequestMethod.POST)
	public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
		return super.importExcel(request, response, StProjectManage.class);
	}

}
